#include<stdio.h>
#include<stdlib.h>

#define TRUE 1
#define FALSE 0
#define INF -1
#define NEDEFINISANO -1

int jeManji(int i, int j)
{
	if(i==INF)
		return FALSE;
	if(j==INF)
		return TRUE;
	return i<j;
}

int nadjiNajmanji(int *obidjen, int *d, int n)
{
	int i;
	int min=INF;
	int minCvor;

	for(i=0; i<n;i++)
	{
		if(obidjen[i] == FALSE && jeManji(d[i],min))
		{
			min=d[i];
			minCvor=i;
		}
	}

	return i;
}

void relax(int **graf, int *d, int *prethodnik, int u, int v)
{
	if(jeManji(graf[u][v] + d[u], d[v]))
	{
		d[v]=graf[u][v] + d[u];
		prethodnik[v]=u;
	}
}

void dijkstra(int **graf,int *obidjen,int *d, int *prethodnik, int n)
{
	int i,u,v;

	for(i=0;i<n;i++)
	{
		u=nadjiNajmanji(obidjen,d,n);
		obidjen[u]=TRUE;
		for(v=0;v<n;v++)
		{
			if(graf[u][v] != INF && obidjen[v] == FALSE)
				relax(graf,d,prethodnik,u,v);
		}
	}
}

int main()
{
	int **graf;
	int *obidjen;
	int *prethodnik;
	int *d;



	int **graf1;
	int *obidjen1;
	int *prethodnik1;
	int *d1;


	int i,j,n,m;
	int u,v;
	int l,k;

	int duzinaSaobracajnice;
	int ogranicenjeBrzine;
	int boja;

	int *granicniPrelaz, *vremeCekanja;
	int gradPolazista,skijaskiGrad;

	scanf("%d %d",&n, &l);
	//printf("%d %d\n",n,l );
	graf=(int **)malloc((n+1) * sizeof(int *));
	graf1=(int **)malloc((n+1) * sizeof(int *));
	for(i=0; i<=n;i++)
	{
		graf[i]=(int *)malloc((n+1) * sizeof(int));
		graf1[i]=(int *)malloc((n+1) * sizeof(int));
	}


	obidjen=(int *)malloc((n+1) * sizeof(int));
	d=(int *)malloc((n+1) * sizeof(int));
	prethodnik=(int *)malloc((n+1) * sizeof(int));




	obidjen1=(int *)malloc((n+1) * sizeof(int));
	d1=(int *)malloc((n+1) * sizeof(int));
	prethodnik1=(int *)malloc((n+1) * sizeof(int));

	granicniPrelaz=(int *)malloc((l+1) * sizeof(int));
	vremeCekanja=(int *)malloc((l+1) * sizeof(int));

	
	for(i=1;i<=n;i++)
		for(j=1; j<=n;j++)
		{
			graf[i][j]=INF;
			graf1[i][j]=INF;
		}
		

	for(i=1; i<=n;i++)
	{
		obidjen[i]=FALSE;
		d[i]=INF;
		prethodnik[i]=NEDEFINISANO;

		obidjen1[i]=FALSE;
		d1[i]=INF;
		prethodnik1[i]=NEDEFINISANO;
	}


	/*for(i=0;i<n;i++)
	{
		for(j=0; j<n;j++)
			printf("%d ",graf[i][j] );
		printf("\n");
	}*/

	//scanf("%d",&l);
	
	for(i=1; i<=l;i++)
	{
		
		scanf("%d%d%d%d%d",&u,&v,&duzinaSaobracajnice,&ogranicenjeBrzine,&boja);
		
		graf[u][v]=graf[v][u] =(60.0/ogranicenjeBrzine) * duzinaSaobracajnice;		// koliko za 1 km minuta
		if(boja == 2)
			graf[u][v] *1.2;
		if(boja == 3)
			graf[u][v]*1.4;				// koliko ce im se povecati vreme u minutima;
		
	}

	
	scanf("%d",&k);
	
	for(i=1;i<=k;i++)
	{
		
		scanf("%d%d",&granicniPrelaz[i],&vremeCekanja[i]);
	}


	scanf("%d%d",&gradPolazista,&skijaskiGrad);
	d[gradPolazista]=0;
	dijkstra(graf,obidjen,d,prethodnik,n);


	for(i=1;i<=n;i++)
	{
		for(j=0;j<n;j++)
			printf("%d ",graf[i][j] );
		printf("\n");
	}


	int izabraniGranicniPrelaz=0;

	for(i=1; i<=k;i++)
	{
		if(d[granicniPrelaz[i]] + vremeCekanja[i] < izabraniGranicniPrelaz || izabraniGranicniPrelaz==0)
		{
			izabraniGranicniPrelaz=i;
		}
	}

	int vreme;
	vreme= d[granicniPrelaz[i]] + vremeCekanja[i];
	//printf("%d\n",vreme );


	d1[granicniPrelaz[i]]=0;
	dijkstra(graf1,obidjen1,d1,prethodnik1,n);
	vreme+=d1[skijaskiGrad];
	printf("%d\n",vreme );

}