#include <stdio.h>
#include <stdlib.h>

#define nedefinisano -1
#define TRUE 1
#define FALSE 0


typedef struct
{
	int u,v;
	int duzina;
	int boja;
	int ogranicenje;
} Veza;

typedef struct
{
	int granicniPrelaz;
	int vremeCekanja;
} Prelaz;

Veza **graf;
Prelaz *drzava;
int granicniPrelaz,vremeCekanja,polaziste,skijaskiCentar;
int u,v,duzina,ogranicenje,boja,k;
int *obidjen,*d,*pret;
int n,l,k;

int jeManji(int i,int j)
{
	if (i==nedefinisano) return FALSE;
	if (j==nedefinisano) return TRUE;
	return i<j;
}

int nadjiMinimum()
{
	int i,min=nedefinisano,minCvor=nedefinisano;
	for (i = 0; i < n; i++)
	{
		if (jeManji(d[i],min) && obidjen[i]==FALSE)
		{
			min = d[i];
			minCvor = i;
		}
	}
	return minCvor;
}


void dijkstra()
{
	int i,v;
	for (i = 0; i < k; i++)
	{
		u = nadjiMinimum();
		obidjen[u] = TRUE;
		for (v = 0; v < l; v++)
		{
			if (obidjen[v] == FALSE && graf[u][v].duzina != nedefinisano)
			{
				if (jeManji(d[u]+graf[u][v].duzina,d[v]))
				{
					if (v == drzava[i].granicniPrelaz) 
					{
						d[v] = d[u]+drzava[i].vremeCekanja/60*graf[u][v].ogranicenje; //ako  cvor v jeste granicni dodaj vreme cekanja 
						pret[v] = u;
					}	
				}
			}
		}
	}
}

void dijkstraGranicni()
{
	int i,v;
	for (i = 0; i < n; i++)
	{
		u = nadjiMinimum();
		obidjen[u] = TRUE;
		for (v = 0; v < n; v++)
		{
			if (obidjen[v] == FALSE && drzava[i].vremeCekanja != nedefinisano)
			{
				if (jeManji(d[u]+drzava[i].vremeCekanja,d[v]))
				{
					d[v] = d[u]+drzava[i].vremeCekanja+graf[u][v].ogranicenje;
					pret[v] = u;
						
				}
			}
		}
	}
}

int rekonstrukcija(int i)
{
	int rbr;
	if (i==polaziste)
	{
		return  -1;
	}
	else
	{
		rbr = rekonstrukcija(pret[i]);
		if (rbr == -1 && d[i]<=skijaskiCentar)
			return i;
		else return rbr;
	}
	return 0;
}

int main()
{
	int i;
	scanf("%d",&n);
	scanf("%d",&l);
	graf = (Veza**)malloc((n+1)*sizeof(Veza*));
	drzava = (Prelaz*)malloc((n+1)*sizeof(Prelaz));
		obidjen = (int*)malloc((n+1)*sizeof(int));
			d = (int*)malloc((n+1)*sizeof(int));
				pret = (int*)malloc((n+1)*sizeof(int));
	
	for (i = 0; i < n+1; i++)
	{
		graf[i] = (Veza*)malloc((n+1)*sizeof(Veza));
		
		obidjen[i] = FALSE;
		d[i] = nedefinisano;
		pret[i] = nedefinisano;
	}
	
	
	for (i = 0; i < l; i++)
	{
		scanf("%d%d%d%d%d",&u,&v,&duzina,&ogranicenje,&boja);
		
		graf[u][v].duzina = duzina;
		graf[u][v].ogranicenje = ogranicenje;
		graf[u][v].boja = boja;
		//jednosmeran, nema drugi smer	
	}
	
	scanf("%d",&k);
	for (i = 0; i < k; i++)
	{
		scanf("%d%d",&granicniPrelaz,&vremeCekanja);
		drzava[i].granicniPrelaz = granicniPrelaz;
		drzava[i].vremeCekanja = vremeCekanja;
		
	}
	
	scanf("%d%d",&polaziste,&skijaskiCentar);
	
	for (u = 0; u < l; u++)
	{
		for (v = 0; v < l; v++)
		{
			if (graf[u][v].boja == 2)
			{
				graf[u][v].ogranicenje = graf[u][v].ogranicenje - ((graf[u][v].ogranicenje*20)/100);
			}
			else if (graf[u][v].boja == 3)
			{
				graf[u][v].ogranicenje = graf[u][v].ogranicenje - ((graf[u][v].ogranicenje*40)/100);
			}
		}
	}
	d[polaziste] = 0;
	dijkstra();
	printf("%d\n",d[skijaskiCentar]*-60);
	for (i = 0; i < n; i++)
		printf("%d\t ",rekonstrukcija(i));

	printf("\n");
	
	return 0;
}
