#include <stdio.h>
#include <stdlib.h>

#define SKUP_N 1
#define SKUP_B 0

double **A, *b, *c, *x, v;
int *NB, n, m;

void unesiPodatke(){
	int i, j;
	
	n = 3;
	m = 4;
	
	A = (double**) malloc((n+m+1) * sizeof(double*));
	for(i=1;i<=n+m;i++)
		A[i] = (double*) malloc((n+m+1) * sizeof(double));
	
	for(i=1;i<=n;i++){
		for(j=1;j<=m;j++){
			scanf("%lf", &A[n+j][i]);
		}
	}
	
	b = (double*) malloc((n+m+1) * sizeof(double));
	c = (double*) malloc((n+m+1) * sizeof(double));
	x = (double*) malloc((n+m+1) * sizeof(double));
	NB = (int*) malloc((n+m+1) * sizeof(int));
	
	for(i=1;i<=n+m;i++){
		if(i<=n){
			scanf("%lf", &c[i]);
			NB[i] = SKUP_N;
			b[i] = 0.0;
		}
		else{
			scanf("%lf", &b[i]);
			NB[i] = SKUP_B;
			c[i] = 0.0;
		}
	}
	
	c[1] = c[1] / 10;
	c[2] = (c[2] / 100) * 15;
	c[3] = (c[3] / 100) * 22;
	
	v = 0.0;
}

int nadjiUlaz(){
	int i, e = -1;
	
	for(i=1;i<=n+m;i++){
		if(NB[i] == SKUP_N && c[i] > 0){
			e = i;
			break;
		}
	}
	
	return e;
}


int nadjiIzlaz(int e){
	int l = -1;
	int i;
	double min = -1;
	
	for(i=1;i<=n+m;i++){
		if(NB[i] == SKUP_B && A[i][e] > 0){
			if(min == -1 || b[i] / A[i][e] < min){
				min = b[i] / A[i][e];
				l = i;
			}
		}
	}
	
	return l;
}

void pivot(int e, int l){
	int i, j;
	
	b[e] = b[l] / A[l][e];
	A[e][l] = 1 / A[l][e];
	
	for(j=1;j<=n+m;j++){
		if(NB[j] == SKUP_N && j!=e){
			A[e][j] = A[l][j] / A[l][e];
		}
	}
	
	for(i=1;i<=n+m;i++){
		if(NB[i] == SKUP_B && i!=l){
			b[i] -= A[i][e] * b[e];
			
			for(j=1;j<=n+m;j++){
				if(NB[j] == SKUP_N && j!=e){
					A[i][j] -= A[i][e] * A[e][j];
				}
			}
			
			A[i][l] = -A[i][e] / A[l][e];
		}
	}
	
	for(j=1;j<=n+m;j++){
		if(NB[j] == SKUP_N && j!=e){
			c[j] -= c[e] * A[e][j];
		}
	}
	
	c[l] = - c[e] * A[e][l];
	
	v += c[e] * b[e];
	
	NB[e] = SKUP_B;
	NB[l] = SKUP_N;
}


int main(){
	int i, e, l;
	unesiPodatke();
	
	while((e = nadjiUlaz()) != -1){
		l = nadjiIzlaz(e);
		
		if(l == -1){
			printf("Neogranicen problem!\n");
			break;
		}
		else{
			pivot(e, l);
		}
	}
	
	if(e == -1){
		printf("%.3lf\n", v);
		for(i=1;i<=n;i++){
			if(NB[i] == SKUP_B){
				x[i] = b[i];
			}
			else{
				x[i] = 0.0;
			}
			printf("%.3lf ", x[i]);
		}
		printf("\n");
	}
}
