#include <stdio.h>
#include <stdlib.h>

#define INF -1
#define NILL -1
#define TRUE 1
#define FALSE 0

int jeManji(int i, int j){
	if(i == INF)
		return FALSE;
	if(j == INF)
		return TRUE;
	return i<j;
}

int nadjiMinimum(int *obidjen, int *d, int n){
	int i;
	int min = INF;
	int minCvor = NILL;
	for(i=1;i<=n;i++){
		if(obidjen[i] == FALSE && jeManji(d[i], min)){
			min = d[i];
			minCvor = i;
		}
	}
	
	return minCvor;
}

void relax(double **graf, int *d, int *pret, int u, int v){
	if(jeManji(d[u] + graf[u][v], d[v])){
		d[v] = d[u] + graf[u][v];
		pret[v] = u;
	}
}

void dijkstra(double **graf, int *d, int *obidjen, int *pret, int n){
	int i, u, v;
	
	for(i=1;i<=n;i++){
		u = nadjiMinimum(obidjen, d, n);
		obidjen[u] = TRUE;
		
		for(v=1;v<=n;v++){
			if(graf[u][v] != INF && obidjen[v] == FALSE){
				relax(graf, d, pret, u, v);
			}
		}
	}
}

int rekonstrukcija(int i, int polaziste, int *pret, double *vreme, double **graf){
	if(i == polaziste){
		printf("%.3lf \n", (*vreme) / 60);
		printf("%d ", polaziste);
		return -1;
	}
	else{
		(*vreme) += graf[pret[i]][i];
		rekonstrukcija(pret[i], polaziste, pret, &(*vreme), graf);
		printf("%d ", i);
	}
}

int main(){
	int i, j, n, l, *d, *obidjen, *pret, k, *prelazi, gradPolazista, skijaskiCentar, I, K;
	int rbr, u, v;
	double **graf;
	int boja, ogranicenje;
	double duzina;
	
	scanf("%d%d", &n, &l);
	
	graf = (double**) malloc((n+1)*sizeof(double*));
	for(i=1;i<=n;i++)
		graf[i] = (double*) malloc((n+1)*sizeof(double));
		
	obidjen = (int*) malloc((n+1)*sizeof(int));
	d = (int*) malloc((n+1)*sizeof(int));
	pret = (int*) malloc((n+1)*sizeof(int));
	
	for(i=1;i<=n;i++){
		d[i] = INF;
		pret[i] = NILL;
		obidjen[i] = FALSE;
	}
	
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			graf[i][j] = INF;
	
	for(i=1;i<=l;i++){
		scanf("%d%d%lf%d%d", &u, &v, &duzina, &ogranicenje, &boja);
		if(boja == 1){
			graf[u][v] = graf[v][u] = (duzina / ogranicenje) * 60;
		}
		else if(boja == 2){
			ogranicenje -= ogranicenje/5;
			graf[u][v] = graf[v][u] = (duzina / ogranicenje) * 60;
		}
		else{
			ogranicenje -= (ogranicenje/5) * 2;
			graf[u][v] = graf[v][u] = (duzina / ogranicenje) * 60;
		}
	}
	
	scanf("%d", &k);
	
	for(i=1;i<=k;i++){
		scanf("%d%d", &I, &K);
		for(j=1;j<=n;j++)
			if(graf[j][I] != INF)
				graf[j][I] += K;
	}
	
	
	scanf("%d%d", &gradPolazista, &skijaskiCentar);
	
	d[gradPolazista] = 0;
	dijkstra(graf, d, obidjen, pret, n);
	
	double vreme = 0.0;
	
	rekonstrukcija(skijaskiCentar, gradPolazista, pret, &vreme, graf);
	printf("\n");
}
